!> \file lect-eurasie_mod.f90
!! Module pour la lecture de la topo
!<

!> \namespace  lect_topo_eurasie
!! Lecture de la topo 
!! \author ...
!! \date ...
!! @note Used module
!! @note   - use module3D_phy
!<

module lect_topo_eurasie

  use module3D_phy
  
    character(len=100) :: topo_dep       !< Topo de dpart
    character(len=100) :: topo_ref       !< Topo de rfrence
    character(len=100) :: filin
real,dimension(nx,ny) ::  xcc , ycc      !< coordeonnes en m

contains
 
subroutine input_topo

namelist/topo/topo_ref,topo_dep

428 format(A)

rewind(num_param)        ! pour revenir au debut du fichier param_list.dat
read(num_param,topo)

write(num_rep_42,428)'!___________________________________________________________' 
write(num_rep_42,428) '&topo                            ! module lect_topo_eurasie'
write(num_rep_42,'(A,A)')   'topo_ref =', topo_ref
write(num_rep_42,'(A,A)')   'topo_dep =', topo_dep          
write(num_rep_42,*)'/'                      
write(num_rep_42,428) '! topo_ref= topo actuelle'
write(num_rep_42,*)


topo_ref=trim(dirnameinp)//trim(topo_ref) 
topo_dep=trim(dirnameinp)//trim(topo_dep) 

!     lecture de la topo de rfrence
!     -------------------------------
! Cette topo sert a calculer le socle de reference pour l'isostasie
! voir init_iso et a avoir une surface de reference pour les temperatures

     open (20,file=topo_ref)
       
         do J=1,ny 
          do I=1,nx
            read (20,*) S0(I,J),H0(I,J),Bsoc0(I,J)

             S0(i,j)=max(S0(i,j),0.)   ! pour tre au niveau des mers

          end do
        end do
     close(20)

     
!     lecture de la topo de depart
!     ---------------------------
     open (20,file=topo_dep)
     
         do J=1,ny 
          do I=1,nx
              read (20,*) S(I,J),H(I,J),BSOC(I,J)
          end do
        end do
     close(20)


!--Eurasie 40 --------------------------masque de glace pour enlever le Groenland 
! si mk0=-1 on ne change pas l'epaisseur, mk0=0 -> sans glace

      do j=3,ny-2
         do i=3,nx-2
            mk0(i,j)=1
            if ((i.lt.25).and.(j.gt.35)) mk0(i,j)=-1
         end do
      end do


     
! lecture des coordonnes geographiques

    filin=TRIM(DIRNAMEINP)//'coord-'//geoplace//'.dat'

! les coordonnees sont calculees en dec avec GMT,
! les longitudes sont comprises entre -180 et +180 (negative a l'Ouest de
! Greenwich et positive a l'Est)

open(unit=2004,file=filin,iostat=ios)
do k=1,nx*ny
   read(2004,*) i,j,xcc(i,j),ycc(i,j),xlong(i,j),ylat(i,j)
enddo
close(2004)
write(42,*) 'fichier grille: ', filin
                                       
xmin=xcc(1,1)/1000.
ymin=ycc(1,1)/1000.
xmax=xcc(nx,ny)/1000.
ymax=ycc(nx,ny)/1000.
                        
! lecture du flux geothermique de Shapiro
      open(88,file=(TRIM(DIRNAMEINP)//'ijphi_'//geoplace//'.dat'))

      write(42,*) 'flux geothermique Shapiro :', (TRIM(DIRNAMEINP)//'ijphi_'//geoplace//'.dat')

      do k=1,nx*ny
         read(88,*) i,j,ghf(i,j)
      end do
      close(88)
! pour passer les flux des mW/m2 au J/m2/an      
      ghf(:,:)=-SECYEAR/1000.*ghf(:,:)
!------------------------------------------------     
end subroutine input_topo


end module lect_topo_eurasie
