!> \file output_heino_mod.f90
!! Module de
!<

!> \namespace output_heino
!! Module de 
!! \author ...
!! \date ...
!! @note Used module
!! @note   - use module3D_phy
!! @note   - use sliding_dragging_heino
!<

module  output_heino

USE module3D_phy
use sliding_dragging_heino


implicit none

! 1_initialization
!------------------
REAL ::  VOLtot 
integer ::  NPtot
integer :: nptemp_tot
integer ::  NPtemp_sed
integer :: nbsed
REAL ::  Hmean_sed
REAL ::  tbmean_sed

! definition des points particuliers
integer,parameter  :: nbpoints=7
integer,parameter :: n1=6 ! nombre de sorties avant les points
integer,dimension(nbpoints) :: ipos,jpos
integer,parameter :: nbsortie=nbpoints*4+n1


! positions en km
real,dimension(nbpoints) :: xpos,ypos

! sorties pour ces points 
real,dimension(nbsortie) :: sortie


CONTAINS

subroutine init_outshort

!ndisp sorite courte tous les ndisp
NDISP=100

end subroutine init_outshort

!_________________________________________________________________________
subroutine shortoutput

if (itracebug.eq.1)  call tracebug(' Heino: entree dans routine output_heino')

! 1_initialization
!------------------
VOLtot=0. 
NPtot=0
nptemp_tot=0
NPtemp_sed=0
Hmean_sed=0.
tbmean_sed=0.
nbsed=0.
! definition des positions des points particuliers en km
ypos(:)=2000.

xpos(1)=3900.
xpos(2)=3800.
xpos(3)=3700.
xpos(4)=3500.
xpos(5)=3200.
xpos(6)=2900.
xpos(7)=2600.


do k=1,nbpoints
   ipos(k)=nint(xpos(k)/dx*1000.)+1
   jpos(k)=nint(ypos(k)/dx*1000.)+1
end do


! 2_preparing outputs
!--------------------      
  do I=1,NX 
     do J=1,NY

        if (mksedim(i,j).ge.1) then  ! seulement le grand cercle
          NPtot=NPtot+1   ! nombre de points
          VOLtot=VOLtot+H(I,J)  ! volume total
          if (t(i,j,nz).ge.tpmp(i,j,nz)) then ! points base temperee
              nptemp_tot=nptemp_tot+1 ! 
              if (mksedim(i,j).ge.2) nptemp_sed=nptemp_sed+1 ! seulement ceux du sediment
           endif
         if (mksedim(i,j).ge.2) then
            Hmean_sed=Hmean_sed+H(i,j) ! epaisseur moyenne zone sediment
            tbmean_sed=tbmean_sed+(t(i,j,nz)-tpmp(i,j,nz))+273.15
            nbsed=nbsed+1
         endif
      endif
    end do
  end do

nbsed=max(nbsed,1)  ! pour eviter une division par 0.

sortie(1)=time
sortie(2)=voltot*dx*dx/1.e15
sortie(3)=nptemp_tot*dx*dx/1.e12
sortie(4)=hmean_sed/nbsed/1.e3
sortie(5)=nptemp_sed*dx*dx/1.e12
sortie(6)=tbmean_sed/nbsed
l=n1+1
do k=1,7
   i1=ipos(k)
   j1=jpos(k)
   sortie(l)=H(i1,j1)/1000.
   sortie(l+1)=T(i1,j1,nz)-tpmp(i1,j1,nz)
   sortie(l+2)=chalgliss_maj(i1,j1)/secyear
!   sortie(l+2)=rog*Hmx(i1,j1)*sdx(i1,j1)*uxbar(i1,j1)
!   sortie(l+3)=rog*Hmx(i1+1,j1)*sdx(i1+1,j1)*uxbar(i1+1,j1) 
   sortie(l+3)=0.5*(uxbar(i1,j1)+uxbar(i1+1,j1))
   l=l+4
end do


! 2_writing outputs
!------------------    
!     **** short display **** 


  write(num_ritz,fmt='(34(es14.6,1x))') (sortie(k),k=1,nbsortie)
  

end subroutine shortoutput

end module output_heino
